/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import java.util.Calendar;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.MotivoDevolucaoBilhete;
import com.rjconsultores.ventaboletos.service.MotivoDevolucaoBilheteService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

/**
 * 
 * @author Bruno Neves
 */
@Controller("editarMotivoDevolucaoBilheteController")
@Scope("prototype")
public class EditarMotivoDevolucaoBilheteController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;

	@Autowired
	private MotivoDevolucaoBilheteService motivoDevolucaoBilheteService;
	private MotivoDevolucaoBilhete motivoDevolucaoBilhete;
	private MyListbox motivoDevolucaoBilheteList;
	private static Logger log = LogManager.getLogger(EditarMotivoDevolucaoBilheteController.class);
	private Textbox txtNome;
	private Button btnApagar;


	public Button getBtnApagar() {
		return btnApagar;
	}

	public void setBtnApagar(Button btnApagar) {
		this.btnApagar = btnApagar;
	}

	public Textbox getTxtNome() {
		return txtNome;
	}

	public void setTxtNome(Textbox txtNome) {
		this.txtNome = txtNome;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		motivoDevolucaoBilhete = (MotivoDevolucaoBilhete) Executions.getCurrent().getArg().get("motivoDevolucaoBilhete");
		motivoDevolucaoBilheteList = (MyListbox) Executions.getCurrent().getArg().get("motivoDevolucaoBilheteList");

		if (motivoDevolucaoBilhete.getMotivodevolucaobilheteId() == null) {
			btnApagar.setVisible(Boolean.FALSE);
		} else {
			if (motivoDevolucaoBilheteService.validaMotivoDevolucaoBilheteConstante(motivoDevolucaoBilhete)) {
				btnApagar.setVisible(false);
				txtNome.setDisabled(true);

				Messagebox.show(
						Labels.getLabel("MSG.noEditabled"),
						Labels.getLabel("editarMotivoDevolucaoBilheteController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
		}
		if(motivoDevolucaoBilhete.getMotivodevolucaobilheteId() != null){
			if (motivoDevolucaoBilhete.getMotivodevolucaobilheteId() == 1 ) {
				btnApagar.setVisible(Boolean.FALSE);
				txtNome.setDisabled(Boolean.TRUE);
				

				Messagebox.show(
						Labels.getLabel("MSG.noEditabled"),
						Labels.getLabel("editarFormaPagoController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
		}
		

		txtNome.focus();
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		txtNome.getValue();
		try {
			motivoDevolucaoBilhete.setDescmotivo(txtNome.getValue());
			motivoDevolucaoBilhete.setActivo(true);
			motivoDevolucaoBilhete.setFecmodif(Calendar.getInstance().getTime());
			motivoDevolucaoBilhete.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
			if (motivoDevolucaoBilhete.getMotivodevolucaobilheteId() == null) {
				motivoDevolucaoBilhete = motivoDevolucaoBilheteService.suscribir(motivoDevolucaoBilhete);
				motivoDevolucaoBilheteList.addItem(motivoDevolucaoBilhete);
			}else{
				motivoDevolucaoBilhete = motivoDevolucaoBilheteService.actualizacion(motivoDevolucaoBilhete);
				motivoDevolucaoBilheteList.updateItem(motivoDevolucaoBilhete);;
			}
			closeWindow();
			
		} catch (Exception ex) {
			log.error("editarMotivoDevolucaoBilheteController: " + ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarMotivoDevolucaoBilheteController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			
			int resp = Messagebox.show(
					Labels.getLabel("editarMotivoDevolucaoBilheteController.MSG.borrarPergunta"),
					Labels.getLabel("editarMotivoDevolucaoBilheteController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				motivoDevolucaoBilheteService.borrar(motivoDevolucaoBilhete);

				Messagebox.show(
						Labels.getLabel("editarMotivoDevolucaoBilheteController.MSG.borrarOK"),
						Labels.getLabel("editarMotivoDevolucaoBilheteController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				motivoDevolucaoBilheteList.removeItem(motivoDevolucaoBilhete);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public MotivoDevolucaoBilhete getMotivoDevolucaoBilhete() {
		return motivoDevolucaoBilhete;
	}

	public void setMotivoDevolucaoBilhete(MotivoDevolucaoBilhete motivoDevolucaoBilhete) {
		this.motivoDevolucaoBilhete = motivoDevolucaoBilhete;
	}

	public MyListbox getMotivoDevolucaoBilheteList() {
		return motivoDevolucaoBilheteList;
	}

	public void setMotivoDevolucaoBilheteList(MyListbox motivoDevolucaoBilheteList) {
		this.motivoDevolucaoBilheteList = motivoDevolucaoBilheteList;
	}

	public MotivoDevolucaoBilheteService getMotivoDevolucaoBilheteService() {
		return motivoDevolucaoBilheteService;
	}

	public void setMotivoDevolucaoBilheteService(MotivoDevolucaoBilheteService motivoDevolucaoBilheteService) {
		this.motivoDevolucaoBilheteService = motivoDevolucaoBilheteService;
	}
}
